// K4-7
// int^Œ蒷fbN

public class IntDeque {

	//--- sOFL[ ---//
	public class EmptyIntDequeException extends RuntimeException {
		public EmptyIntDequeException() { }
	}

	//--- sOFL[t ---//
	public class OverflowIntDequeException extends RuntimeException {
		public OverflowIntDequeException() { }
	}

	private int[] que;			// fbN̖{
	private int capacity;		// fbN̗e
	private int num;				// ݂̃f[^
	private int front;			// 擪vfJ[\
	private int rear;				// vfJ[\

	//--- RXgN^ ---//
	public IntDeque(int maxlen) {
		num = front = rear = 0;
		capacity = maxlen;
		try {
			que = new int[capacity];				// fbN{̗p̔z𐶐
		} catch (OutOfMemoryError e) {		// łȂ
			capacity = 0;
		}
	}

	//--- fbNɃf[^擪GL[ ---//
	public int enqueFront(int x) throws OverflowIntDequeException {
		if (num >= capacity)
			throw new OverflowIntDequeException();		// fbN͖t
		num++;
		if (--front < 0)
			front = capacity - 1;
		que[front] = x;
		return x;
	}

	//--- fbNɃf[^𖖔GL[ ---//
	public int enqueRear(int x) throws OverflowIntDequeException {
		if (num >= capacity)
			throw new OverflowIntDequeException();		// fbN͖t
		que[rear++] = x;
		num++;
		if (rear == capacity)
			rear = 0;
		return x;
	}

	//--- fbN̐擪f[^fL[ ---//
	public int dequeFront() throws EmptyIntDequeException {
		if (num <= 0)
			throw new EmptyIntDequeException();				// fbN͋
		int x = que[front++];
		num--;
		if (front == capacity)
			front = 0;
		return x;
	}

	//--- fbN̖f[^fL[ ---//
	public int dequeRear() throws EmptyIntDequeException {
		if (num <= 0)
			throw new EmptyIntDequeException();				// fbN͋
		num--;
		if (--rear < 0)
			rear = capacity - 1;
		return que[rear];
	}

	//--- fbN̐擪f[^s[Ni擪f[^`j ---*/
	public int peekFront() throws EmptyIntDequeException {
		if (num <= 0)
			throw new EmptyIntDequeException();				// fbN͋
		return que[front];
	}

	//--- fbN̖f[^s[Nif[^`j ---*/
	public int peekRear() throws EmptyIntDequeException {
		if (num <= 0)
			throw new EmptyIntDequeException();				// fbN͋
		return que[rear == 0 ? capacity - 1 : rear - 1];
	}

	//--- fbNxTăCfbNXiȂ-1jԂ ---//
	public int indexOf(int x) {
		for (int i = 0; i < num; i++) {
			int idx = (i + front) % capacity;
			if (que[idx] == x)											// T
				return idx;
		}
		return -1;																// Ts
	}

	//--- fbNxTĐ擪牽ԖڂiȂ0jԂ ---//
	public int search(int x) {
		for (int i = 0; i < num; i++)
			if (que[(i + front) % capacity]  == x)	// T
				return i + 1;
		return 0;																	// Ts
	}

	//--- fbNɂ ---//
	public void clear() {
		num = front = rear = 0;
	}

	//--- fbN̗eʂԂ ---//
	public int getCapacity() {
		return capacity;
	}

	//--- fbNɒ~Ăf[^Ԃ ---//
	public int size() {
		return num;
	}

	//--- fbN͋ł邩 ---//
	public boolean isEmpty() {
		return num <= 0;
	}

	//--- fbN͖tł邩 ---//
	public boolean isFull() {
		return num >= capacity;
	}

	//--- fbN̑Sf[^擪̏ɕ\ ---//
	public void dump() {
		if (num <= 0)
			System.out.println("fbN͋łB");
		else {
			for (int i = 0; i < num; i++)
				System.out.print(que[(i + front) % capacity] + " ");
			System.out.println();
		}
	}
}

