// K4-6
// ėpL[

public class Queue<E> {

	//--- sOFL[ ---//
	public static class EmptyGqueueException extends RuntimeException {
		public EmptyGqueueException() { }
	}

	//--- sOFL[t ---//
	public static class OverflowGqueueException extends RuntimeException {
		public OverflowGqueueException() { }
	}

	private E[] que;			// L[̖{
	private int capacity;			// L[̗e
	private int num;			// ݂̃f[^
	private int front;		// 擪vfJ[\
	private int rear;			// vfJ[\

	//--- RXgN^ ---//
	public Queue(int maxlen) {
		num = front = rear = 0;
		capacity = maxlen;
		try {
			que = (E [])new Object[capacity];		// L[{̗p̔z𐶐
		} catch (OutOfMemoryError e) {				// łȂ
			capacity = 0;
		}
	}

	//--- L[Ƀf[^GL[ ---//
	public E enque(E x) throws OverflowGqueueException {
		if (num >= capacity)
			throw new OverflowGqueueException();		// L[͖t
		que[rear++] = x;
		num++;
		if (rear == capacity)
			rear = 0;
		return x;
	}

	//--- L[f[^fL[ ---//
	public E deque() throws EmptyGqueueException {
		if (num <= 0)
			throw new EmptyGqueueException();				// L[͋
		E x = que[front++];
		num--;
		if (front == capacity)
			front = 0;
		return x;
	}

	//--- L[f[^s[Ni擪f[^`j ---*/
	public E peek() throws EmptyGqueueException {
		if (num <= 0)
			throw new EmptyGqueueException();				// L[͋
		return que[front];
	}

	//--- L[xTăCfbNXiȂ-1jԂ ---//
	public int indexOf(E x) {
		for (int i = 0; i < num; i++)
			if (que[(i + front) % capacity].equals(x))	// T
				return i + front;
		return -1;																		// Ts
	}

	//--- L[xTĐ擪牽ԖڂiȂ-1jԂ ---//
	public int search(E x) {
		for (int i = 0; i < num; i++)
			if (que[(i + front) % capacity].equals(x))	// T
				return i + 1;
		return -1;																		// Ts
	}

	//--- L[ɂ ---//
	public void clear() {
		num = front = rear = 0;
	}

	//--- L[̗eʂԂ ---//
	public int getCapacity() {
		return capacity;
	}

	//--- L[ɒ~Ăf[^Ԃ ---//
	public int size() {
		return num;
	}

	//--- L[͋ł邩 ---//
	public boolean isEmpty() {
		return num <= 0;
	}

	//--- L[͖tł邩 ---//
	public boolean isFull() {
		return num >= capacity;
	}

	//--- L[̑Sf[^擪̏ɕ\ ---//
	public void dump() {
		if (num <= 0)
			System.out.println("L[͋łB");
		else {
			for (int i = 0; i < num; i++)
				System.out.print(que[(i + front) % capacity].toString() + " ");
			System.out.println();
		}
	}
}
