// K8-7
// zXgNX

import java.util.Comparator;

public class CircularLinkedList<E> {

	//--- m[h ---//
	class Node<E> {
		E data;					// f[^
		Node<E> next;		// 㑱|C^i㑱m[hւ̎QƁj

		//--- RXgN^ ---//
		Node(E data) {
			this.data = data;
			this.next = this;
		}

		//--- RXgN^ ---//
		Node(E data, Node<E> next) {
			this.data = data;
			this.next = next;
		}
	}

	private Node<E> head;			// 擪m[h
	private Node<E> tail;			// m[h
	private Node<E> crnt;			// ڃm[h

	//--- RXgN^ ---//
	public CircularLinkedList() {
		head = tail = crnt = null;
	}

	//--- m[hT ---//
	public E search(E o, Comparator<? super E> c) {
		if (head != null) {
			Node<E> ptr = head;					// ݑ̃m[h

			do {
				if (c.compare(o, ptr.data) == 0) {	// T
					crnt = ptr;
					return ptr.data;
				}
				ptr = ptr.next; 						// 㑱m[hɒ
			} while (ptr != head);
		}
		return null;										// Ts
	}

	//--- 擪Ƀm[h} ---//
	public void addFirst(E o) {
		if (head == null)
			head = tail = crnt = new Node<E>(o);
		else {
			Node<E> ptr = head;
			head = crnt = new Node<E>(o, ptr);
			tail.next = head;
		}
	}

	//--- Ƀm[h} ---//
	public void addLast(E o) {
		if (head == null)			// Xgł
			addFirst(o);				// 擪ɑ}
		else {
			Node<E> ptr = tail;
			ptr.next = crnt = tail = new Node<E>(o, head);
		}
	}

	//--- 擪m[h폜 ---//
	public void removeFirst() {
		if (head != null) {					// XgłȂ
			if (head == tail)
				head = tail = crnt = null;
			else {
				Node<E> ptr = head.next;
				head = crnt = ptr;
				tail.next = head;
			}
		}
	}

	//--- m[h폜 ---//
	public void removeLast() {
		if (head != null) {
			if (head == tail)					// m[hł
				removeFirst();					// 擪m[h폜
			else {
				Node<E> ptr = head;			// ̃m[h
				Node<E> pre = head;			// ̃m[h̐sm[h

				while (ptr.next != head) {
					pre = ptr;
					ptr = ptr.next;
				}
				pre.next = head;				// pre͍폜̖m[h
				tail = crnt = pre;
			}
		}
	}

	//--- m[hp폜 ---//
	public void remove(Node<E> p) {
		if (head != null) {
			if (p == head)					// p擪m[hł
				removeFirst();				// 擪m[h폜
			else if (p == tail)			// pm[hł
				removeLast();					// m[h폜
			else {
				Node<E> ptr = head;

				while (ptr.next != p) {
					ptr = ptr.next;
					if (ptr == head) return;	// p̓Xgɑ݂Ȃ
				}
				ptr.next = p.next;
				crnt = ptr;
			}
		}
	}

	//--- ڃm[h폜 ---//
	public void removeCurrentNode() {
		remove(crnt);
	}

	//--- Sm[h폜 ---//
	public void clear() {
		while (head != null)		// ɂȂ܂
			removeFirst();				// 擪m[h폜
		crnt = null;
	}

	//--- ڃm[hɐi߂ ---//
	public boolean next() {
		if (crnt == null || crnt.next == head)
			return false;					// i߂邱Ƃ͂łȂ
		crnt = crnt.next;
		return true;
	}

	//--- ڃm[h\ ---//
	public void printCurrentNode() {
		if (crnt == null)
			System.out.println("ڃm[h͂܂B");
		else
			System.out.println(crnt.data.toString());
	}

	//--- Sm[h\ ---//
	public void dump() {
		if (head != null) {
			Node<E> ptr = head;

			do {
				System.out.println(ptr.data.toString());
				ptr = ptr.next;
			} while (ptr != head);
		}
	}

	//--- Rp[^cɂČ݂ɓƂ݂Ȃm[hׂč폜 ---//
	public void purge(Comparator<? super E> c) {
		if (head == null) return;
		Node<E> ptr = head;

		do {
			int count = 0;
			Node<E> ptr2 = ptr;
			Node<E> pre = ptr;

			while (pre.next != head) {
				ptr2 = pre.next;
				if (c.compare(ptr.data, ptr2.data) == 0) {
					remove(ptr2);
					count++;
				} else
					pre = ptr2;
			}
			if (count == 0)
				ptr = ptr.next;
			else {
				Node<E> temp = ptr;
				remove(ptr);
				ptr = temp.next;
			}
		} while (ptr.next != head);
		crnt = head;
	}

	//--- 擪n̃m[h̃f[^ւ̎QƂԋp ---//
	public E retrieve(int n) {
		if (head != null) {
			Node<E> ptr = head;

			while (n >= 0) {
				if (n-- == 0) {
					crnt = ptr;
					return ptr.data;			// T
				}
				ptr = ptr.next;						// 㑱m[hɒ
				if (ptr == head) break;
			}
		}
		return null;
	}
}
