// K8-9{K8-10
// zEdAXgNX

import java.util.Comparator;

public class DoubleLinkedList<E> {

	//--- m[h ---//
	class Node<E> {
		private E data;					// f[^
		private Node<E> prev;		// s|C^ism[hւ̎QƁj
		private Node<E> next;		// 㑱|C^i㑱m[hւ̎QƁj

		//--- RXgN^ ---//
		Node() {
			data = null;
			prev = next = this;
		}

		//--- RXgN^ ---//
		Node(E obj, Node<E> prev, Node<E> next) {
			data = obj;
			this.prev = prev;
			this.next = next;
		}
	}

	private Node<E> head;		// 擪|C^iQƐ̓_~[m[hj
	private Node<E> crnt;		// ڃ|C^

	//--- RXgN^ ---//
	public DoubleLinkedList() {
		head = crnt = new Node<E>();		// _~[m[h𐶐
	}

	//--- Xg͋ ---//
	public boolean isEmpty() {
		return head.next == head;
	}

	//--- m[hT ---//
	public E search(E obj, Comparator<? super E> c) {
		Node<E> ptr = head.next;				// ݑ̃m[h

		while (ptr != head) {
			if (c.compare(obj, ptr.data) == 0) {
				crnt = ptr;
				return ptr.data;						// T
			}
			ptr = ptr.next;								// 㑱m[hɒ
		}
		return null;										// Ts
	}

	//--- ڃm[h\ ---//
	public void printCurrentNode() {
		if (isEmpty())
			System.out.println("ڃm[h͂܂B");
		else
			System.out.println(crnt.data);
	}

	//--- Sm[h\ ---//
	public void dump() {
		Node<E> ptr = head.next;				// _~[m[ȟ㑱m[h

		while (ptr != head) {
			System.out.println(ptr.data);
			ptr = ptr.next;
		}
	}

	//--- Sm[htɕ\ ---//
	public void dumpReverse() {
		Node<E> ptr = head.prev;				// _~[m[h̐sm[h

		while (ptr != head) {
			System.out.println(ptr.data);
			ptr = ptr.prev;
		}
	}

	//--- ڃm[hɐi߂ ---//
	public boolean next() {
		if (isEmpty() || crnt.next == head)
			return false;									// i߂邱Ƃ͂łȂ
		crnt = crnt.next;
		return true;
	}

	//--- ڃm[hOɐi߂ ---//
	public boolean prev() {
		if (isEmpty() || crnt.prev == head)
			return false;									// i߂邱Ƃ͂łȂ
		crnt = crnt.prev;
		return true;
	}

	//--- ڃm[h̒Ƀm[h} ---//
	public void add(E obj) {
		Node<E> node = new Node<E>(obj, crnt, crnt.next);
		crnt.next = crnt.next.prev = node;
		crnt = node;
	}

	//--- 擪Ƀm[h} ---//
	public void addFirst(E obj) {
		crnt = head;										// _~[m[hhead̒ɑ}
		add(obj);
	}

	//--- Ƀm[h} ---//
	public void addLast(E obj) {
		crnt = head.prev;								// m[hhead.prev̒ɑ}
		add(obj);
	}

	//--- ڃm[h폜 ---//
	public void removeCurrentNode() {
		if (!isEmpty()) {
			crnt.prev.next = crnt.next;
			crnt.next.prev = crnt.prev;
			crnt = crnt.prev;
			if (crnt == head) crnt = head.next;
		}
	}

	//--- m[hp폜 ---//
	public void remove(Node p) {
		Node<E> ptr = head.next;

		while (ptr != head) {
			if (ptr == p) {								// p
				crnt = p;
				removeCurrentNode();
				break;
			}
			ptr = ptr.next;
		}
	}

	//--- 擪m[h폜 ---//
	public void removeFirst() {
		crnt = head.next;								// 擪m[hhead.next폜
		removeCurrentNode();
	}

	//--- m[h폜 ---//
	public void removeLast() {
		crnt = head.prev;								// m[hhead.prev폜
		removeCurrentNode();
	}

	//--- Sm[h폜 ---//
	public void clear() {
		while (!isEmpty())							// ɂȂ܂
			removeFirst();								// 擪m[h폜
	}

	//---yK8-9zRp[^cɂČ݂ɓƂ݂Ȃm[hׂč폜 ---//
	public void purge(Comparator<? super E> c) {
		Node<E> ptr = head.next;

		while (ptr.next != head) {
			int count = 0;
			Node<E> ptr2 = ptr;
			Node<E> pre = ptr;

			while (pre.next != head) {
				ptr2 = pre.next;
				if (c.compare(ptr.data, ptr2.data) == 0) {
					pre.next = ptr2.next;
					count++;
				} else
					pre = ptr2;
			}
			if (count == 0)
				ptr = ptr.next;
			else {
				Node<E> temp = ptr;
				remove(ptr);
				ptr = temp.next;
			}
		}
		crnt = head;
	}

	//---yK8-10z擪n̃m[h̃f[^ւ̎QƂԋp ---//
	public E retrieve(int n) {
		Node<E> ptr = head.next;

		while (n >= 0 && ptr.next.next != head) {
			if (n-- == 0) {
				crnt = ptr;
				return ptr.data;		// T
			}
			ptr = ptr.next;				// 㑱m[hɒ
		}
		return null;
	}
}
