// K8-1{K8-2
// `XgNXi\bhpurgeretrieveǉj

import java.util.Comparator;

public class LinkedList<E> {

	//--- m[h ---//
	class Node<E> {
		private E data;					// f[^
		private Node<E> next;		// 㑱|C^i㑱m[hւ̎QƁj

		//--- RXgN^ ---//
		Node(E data, Node<E> next) {
			this.data = data;
			this.next = next;
		}
	}

	private Node<E> head;		// 擪|C^i擪m[hւ̎QƁj
	private Node<E> crnt;		// ڃ|C^iڃm[hւ̎QƁj

	//--- RXgN^ ---//
	public LinkedList() {
		head = crnt = null;
	}

	//--- m[hT ---//
	public E search(E obj, Comparator<? super E> c) {
		Node<E> ptr = head;							// ݑ̃m[h

		while (ptr != null) {
			if (c.compare(obj, ptr.data) == 0) {	// T
				crnt = ptr;
				return ptr.data;
			}
			ptr = ptr.next;								// 㑱m[hɒ
		}
		return null;										// Ts
	}

	//--- 擪Ƀm[h} ---//
	public void addFirst(E obj) {
		Node<E> ptr = head;					// }O̐擪m[h
		head = crnt = new Node<E>(obj, ptr);
	}

	//--- Ƀm[h} ---//
	public void addLast(E obj) {
		if (head == null)				// Xgł
			addFirst(obj);				// 擪ɑ}
		else {
			Node<E> ptr = head;
			while (ptr.next != null)
				ptr = ptr.next;
			ptr.next = crnt = new Node<E>(obj, null);
		}
	}

	//--- 擪m[h폜 ---//
	public void removeFirst() {
		if (head != null)						// XgłȂ
			head = crnt = head.next;
	}

	//--- m[h폜 ---//
	public void removeLast() {
		if (head != null) {
			if (head.next == null)		// m[hł
				removeFirst();					// 擪m[h폜
			else {
				Node<E> ptr = head;			// ̃m[h
				Node<E> pre = head;			// ̃m[h̐sm[h

				while (ptr.next != null) {
					pre = ptr;
					ptr = ptr.next;
				}
				pre.next = null;				// pre͍폜̖m[h
				crnt = pre;
			}
		}
	}

	//--- m[hp폜 ---//
	public void remove(Node p) {
		if (head != null) {
			if (p == head)				// p擪m[hł
				removeFirst();			// 擪m[h폜
			else {
				Node<E> ptr = head;

				while (ptr.next != p) {
					ptr = ptr.next;
					if (ptr == null) return;	// p̓Xgɑ݂Ȃ
				}
				ptr.next = p.next;
				crnt = ptr;
			}
		}
	}

	//--- ڃm[h폜 ---//
	public void removeCurrentNode() {
		remove(crnt);
	}

	//--- Sm[h폜 ---//
	public void clear() {
		while (head != null)		// ɂȂ܂
			removeFirst();				// 擪m[h폜
		crnt = null;
	}

	//--- ڃm[hɐi߂ ---//
	public boolean next() {
		if (crnt == null || crnt.next == null)
			return false;					// i߂邱Ƃ͂łȂ
		crnt = crnt.next;
		return true;
	}

	//--- ڃm[h\ ---//
	public void printCurrentNode() {
		if (crnt == null)
			System.out.println("ڃm[h͂܂B");
		else
			System.out.println(crnt.data);
	}

	//--- Sm[h\ ---//
	public void dump() {
		Node<E> ptr = head;

		while (ptr != null) {
			System.out.println(ptr.data);
			ptr = ptr.next;
		}
	}

	//---yK8-1zRp[^cɂČ݂ɓƂ݂Ȃm[hׂč폜 ---//
	public void purge(Comparator<? super E> c) {
		Node<E> ptr = head;

		while (ptr != null) {
			int count = 0;
			Node<E> ptr2 = ptr;
			Node<E> pre = ptr;

			while (pre.next != null) {
				ptr2 = pre.next;
				if (c.compare(ptr.data, ptr2.data) == 0) {
					pre.next = ptr2.next;
					count++;
				} else
					pre = ptr2;
			}
			if (count == 0)
				ptr = ptr.next;
			else {
				Node<E> temp = ptr;
				remove(ptr);
				ptr = temp.next;
			}
		}
		crnt = head;
	}

  //---yK8-2z擪n̃m[h̃f[^ւ̎QƂԋp ---//
  public E retrieve(int n) {
		Node<E> ptr = head;

		while (n >= 0 && ptr != null) {
			if (n-- == 0) {
				crnt = ptr;
				return ptr.data;				// T
			}
			ptr = ptr.next;						// 㑱m[hɒ
		}
		return null;
	}
}

